/* A Bison parser, made by GNU Bison 2.1.  */

/* C++ Skeleton parser for LALR(1) parsing with Bison,
   Copyright (C) 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

// Take the name prefix into account.
#define yylex   velex

#include "ValueExpressionParser.tab.hh"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* A pseudo ostream that takes yydebug_ into account. */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

/* Enable debugging if requested.  */
#if YYDEBUG

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << (Title) << ' ';			\
      yysymprint_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (0)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yyreduce_print_ (Rule);		\
} while (0)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (0)

#else /* !YYDEBUG */

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

#if YYERROR_VERBOSE

/* Return YYSTR after stripping away unnecessary quotes and
   backslashes, so that it's suitable for yyerror.  The heuristic is
   that double-quoting is unnecessary unless the string contains an
   apostrophe, a comma, or backslash (other than backslash-backslash).
   YYSTR is taken from yytname.  */
std::string
yy::ValueExpressionParser::yytnamerr_ (const char *yystr)
{
  if (*yystr == '"')
    {
      std::string yyr = "";
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    yyr += *yyp;
	    break;

	  case '"':
	    return yyr;
	  }
    do_not_strip_quotes: ;
    }

  return yystr;
}

#endif

#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

void
yy::ValueExpressionParser::yysymprint_ (int yytype,
                         const semantic_type* yyvaluep, const location_type* yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;
  /* Backward compatibility, but should be removed eventually. */
  std::ostream& cdebug_ = *yycdebug_;
  (void) cdebug_;

  *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	     << ' ' << yytname_[yytype] << " ("
             << *yylocationp << ": ";
  switch (yytype)
    {
      case 3: /* "\"scalarID\"" */
#line 126 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->name); };
#line 146 "ValueExpressionParser.tab.cc"
        break;
      case 4: /* "\"vectorID\"" */
#line 126 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->vname); };
#line 151 "ValueExpressionParser.tab.cc"
        break;
      case 5: /* "\"faceScalarID\"" */
#line 126 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->fsname); };
#line 156 "ValueExpressionParser.tab.cc"
        break;
      case 6: /* "\"faceVectorID\"" */
#line 126 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->fvname); };
#line 161 "ValueExpressionParser.tab.cc"
        break;
      case 7: /* "\"cellSetID\"" */
#line 126 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->setname); };
#line 166 "ValueExpressionParser.tab.cc"
        break;
      case 8: /* "\"number\"" */
#line 129 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->val); };
#line 171 "ValueExpressionParser.tab.cc"
        break;
      case 9: /* "\"vector\"" */
#line 127 "ValueExpressionParser.yy"
        { Foam::OStringStream buff; buff << *(yyvaluep->vec); debug_stream () << buff.str().c_str(); };
#line 176 "ValueExpressionParser.tab.cc"
        break;
      case 10: /* "\"expression\"" */
#line 130 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->sfield)->name().c_str(); };
#line 181 "ValueExpressionParser.tab.cc"
        break;
      case 11: /* "\"lexpression\"" */
#line 130 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->sfield)->name().c_str(); };
#line 186 "ValueExpressionParser.tab.cc"
        break;
      case 12: /* "\"vexpression\"" */
#line 130 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->vfield)->name().c_str(); };
#line 191 "ValueExpressionParser.tab.cc"
        break;
      case 13: /* "\"fsexpression\"" */
#line 130 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->fsfield)->name().c_str(); };
#line 196 "ValueExpressionParser.tab.cc"
        break;
      case 14: /* "\"fvexpression\"" */
#line 130 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->fvfield)->name().c_str(); };
#line 201 "ValueExpressionParser.tab.cc"
        break;
      default:
        break;
    }
  *yycdebug_ << ')';
}
#endif /* ! YYDEBUG */

void
yy::ValueExpressionParser::yydestruct_ (const char* yymsg,
                         int yytype, semantic_type* yyvaluep, location_type* yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yymsg;
  (void) yyvaluep;
  (void) yylocationp;

  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 3: /* "\"scalarID\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->name); };
#line 226 "ValueExpressionParser.tab.cc"
        break;
      case 4: /* "\"vectorID\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->vname); };
#line 231 "ValueExpressionParser.tab.cc"
        break;
      case 5: /* "\"faceScalarID\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->fsname); };
#line 236 "ValueExpressionParser.tab.cc"
        break;
      case 6: /* "\"faceVectorID\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->fvname); };
#line 241 "ValueExpressionParser.tab.cc"
        break;
      case 7: /* "\"cellSetID\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->setname); };
#line 246 "ValueExpressionParser.tab.cc"
        break;
      case 9: /* "\"vector\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->vec); };
#line 251 "ValueExpressionParser.tab.cc"
        break;
      case 10: /* "\"expression\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->sfield); };
#line 256 "ValueExpressionParser.tab.cc"
        break;
      case 11: /* "\"lexpression\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->sfield); };
#line 261 "ValueExpressionParser.tab.cc"
        break;
      case 12: /* "\"vexpression\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->vfield); };
#line 266 "ValueExpressionParser.tab.cc"
        break;
      case 13: /* "\"fsexpression\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->fsfield); };
#line 271 "ValueExpressionParser.tab.cc"
        break;
      case 14: /* "\"fvexpression\"" */
#line 128 "ValueExpressionParser.yy"
        { delete (yyvaluep->fvfield); };
#line 276 "ValueExpressionParser.tab.cc"
        break;

      default:
        break;
    }
}

void
yy::ValueExpressionParser::yypop_ (unsigned int n)
{
  yystate_stack_.pop (n);
  yysemantic_stack_.pop (n);
  yylocation_stack_.pop (n);
}

std::ostream&
yy::ValueExpressionParser::debug_stream () const
{
  return *yycdebug_;
}

void
yy::ValueExpressionParser::set_debug_stream (std::ostream& o)
{
  yycdebug_ = &o;
}


yy::ValueExpressionParser::debug_level_type
yy::ValueExpressionParser::debug_level () const
{
  return yydebug_;
}

void
yy::ValueExpressionParser::set_debug_level (debug_level_type l)
{
  yydebug_ = l;
}


int
yy::ValueExpressionParser::parse ()
{
  /* Look-ahead and look-ahead in internal form.  */
  int yylooka;
  int yyilooka;

  /// Semantic value of the look-ahead.
  semantic_type yylval;
  /// Location of the look-ahead.
  location_type yylloc;
  /// The locations where the error started and ended.
  location yyerror_range[2];

  /// $$.
  semantic_type yyval;
  /// @$.
  location_type yyloc;

  int yyresult_;

  YYCDEBUG << "Starting parse" << std::endl;

  yynerrs_ = 0;
  yyerrstatus_ = 0;

  /* Start.  */
  yystate_ = 0;
  yylooka = yyempty_;


  /* User initialization code. */
  #line 37 "ValueExpressionParser.yy"
{
	     // Initialize the initial location.
	     //     @$.begin.filename = @$.end.filename = &driver.file;
}
/* Line 548 of yacc.c.  */
#line 356 "ValueExpressionParser.tab.cc"
  /* Initialize the stacks.  The initial state will be pushed in
     yynewstate, since the latter expects the semantical and the
     location values to have been already stored, initialize these
     stacks with a primary value.  */
  yystate_stack_ = state_stack_type (0);
  yysemantic_stack_ = semantic_stack_type (0);
  yylocation_stack_ = location_stack_type (0);
  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yylloc);

  /* New state.  */
yynewstate:
  yystate_stack_.push (yystate_);
  YYCDEBUG << "Entering state " << yystate_ << std::endl;
  goto yybackup;

  /* Backup.  */
yybackup:

  /* Try to take a decision without look-ahead.  */
  yyn_ = yypact_[yystate_];
  if (yyn_ == yypact_ninf_)
    goto yydefault;

  /* Read a look-ahead token.  */
  if (yylooka == yyempty_)
    {
      YYCDEBUG << "Reading a token: ";
      yylooka = yylex (&yylval, &yylloc, driver);
    }


  /* Convert token to internal form.  */
  if (yylooka <= yyeof_)
    {
      yylooka = yyilooka = yyeof_;
      YYCDEBUG << "Now at end of input." << std::endl;
    }
  else
    {
      yyilooka = yytranslate_ (yylooka);
      YY_SYMBOL_PRINT ("Next token is", yyilooka, &yylval, &yylloc);
    }

  /* If the proper action on seeing token ILOOKA_ is to reduce or to
     detect an error, take that action.  */
  yyn_ += yyilooka;
  if (yyn_ < 0 || yylast_ < yyn_ || yycheck_[yyn_] != yyilooka)
    goto yydefault;

  /* Reduce or error.  */
  yyn_ = yytable_[yyn_];
  if (yyn_ < 0)
    {
      if (yyn_ == yytable_ninf_)
	goto yyerrlab;
      else
	{
	  yyn_ = -yyn_;
	  goto yyreduce;
	}
    }
  else if (yyn_ == 0)
    goto yyerrlab;

  /* Accept?  */
  if (yyn_ == yyfinal_)
    goto yyacceptlab;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yyilooka, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yylooka != yyeof_)
    yylooka = yyempty_;

  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yylloc);

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus_)
    --yyerrstatus_;

  yystate_ = yyn_;
  goto yynewstate;

/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn_ = yydefact_[yystate_];
  if (yyn_ == 0)
    goto yyerrlab;
  goto yyreduce;

/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  yylen_ = yyr2_[yyn_];
  /* If LEN_ is nonzero, implement the default value of the action:
     `$$ = $1'.  Otherwise, use the top of the stack.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  */
  if (yylen_)
    yyval = yysemantic_stack_[yylen_ - 1];
  else
    yyval = yysemantic_stack_[0];

  {
    slice<location_type, location_stack_type> slice (yylocation_stack_, yylen_);
    YYLLOC_DEFAULT (yyloc, slice, yylen_);
  }
  YY_REDUCE_PRINT (yyn_);
  switch (yyn_)
    {
        case 2:
#line 136 "ValueExpressionParser.yy"
    { driver.setScalarResult((yysemantic_stack_[0].sfield));  ;}
    break;

  case 3:
#line 137 "ValueExpressionParser.yy"
    { driver.setVectorResult((yysemantic_stack_[0].vfield));  ;}
    break;

  case 4:
#line 138 "ValueExpressionParser.yy"
    { driver.setLogicalResult((yysemantic_stack_[0].sfield)); ;}
    break;

  case 5:
#line 141 "ValueExpressionParser.yy"
    { (yyval.vfield) = (yysemantic_stack_[0].vfield); ;}
    break;

  case 6:
#line 142 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) + *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 7:
#line 143 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].sfield) * *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 8:
#line 144 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) * *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 9:
#line 145 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) / *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 10:
#line 146 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) ^ *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 11:
#line 147 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) - *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield);;}
    break;

  case 12:
#line 148 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(-*(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 13:
#line 149 "ValueExpressionParser.yy"
    { (yyval.vfield) = (yysemantic_stack_[1].vfield); ;}
    break;

  case 14:
#line 150 "ValueExpressionParser.yy"
    { (yyval.vfield) = driver.doConditional((yysemantic_stack_[4].sfield),(yysemantic_stack_[2].vfield),(yysemantic_stack_[0].vfield),driver.makeVectorField(Foam::vector())); delete (yysemantic_stack_[4].sfield); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 15:
#line 151 "ValueExpressionParser.yy"
    { (yyval.vfield) = driver.makePositionField(); ;}
    break;

  case 16:
#line 152 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::laplacian(*(yysemantic_stack_[3].fsfield),*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[3].fsfield); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 17:
#line 153 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::average(*(yysemantic_stack_[1].fvfield))); delete (yysemantic_stack_[1].fvfield); ;}
    break;

  case 18:
#line 154 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::surfaceIntegrate(*(yysemantic_stack_[1].fvfield))); delete (yysemantic_stack_[1].fvfield); ;}
    break;

  case 19:
#line 155 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::surfaceSum(*(yysemantic_stack_[1].fvfield))); delete (yysemantic_stack_[1].fvfield); ;}
    break;

  case 20:
#line 156 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::grad(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 21:
#line 157 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::reconstruct(*(yysemantic_stack_[1].fsfield))); delete (yysemantic_stack_[1].fsfield); ;}
    break;

  case 22:
#line 158 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::curl(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 23:
#line 159 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::div(*(yysemantic_stack_[3].fsfield),*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[3].fsfield); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 24:
#line 160 "ValueExpressionParser.yy"
    {
            (yyval.vfield)=driver.getVectorField(*(yysemantic_stack_[0].vname));
                    ;}
    break;

  case 25:
#line 165 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[2].fsfield) + *(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[2].fsfield); delete (yysemantic_stack_[0].fsfield); ;}
    break;

  case 26:
#line 166 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[2].fsfield) * *(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[2].fsfield); delete (yysemantic_stack_[0].fsfield); ;}
    break;

  case 27:
#line 167 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[2].fvfield) & *(yysemantic_stack_[0].fvfield)); delete (yysemantic_stack_[2].fvfield); delete (yysemantic_stack_[0].fvfield); ;}
    break;

  case 28:
#line 168 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[2].fsfield) / *(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[2].fsfield); delete (yysemantic_stack_[0].fsfield); ;}
    break;

  case 29:
#line 169 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[2].fsfield) - *(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[2].fsfield); delete (yysemantic_stack_[0].fsfield);;}
    break;

  case 30:
#line 170 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(-*(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[0].fsfield); ;}
    break;

  case 31:
#line 171 "ValueExpressionParser.yy"
    { (yyval.fsfield) = (yysemantic_stack_[1].fsfield); ;}
    break;

  case 32:
#line 172 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::mag(*(yysemantic_stack_[1].fsfield))); delete (yysemantic_stack_[1].fsfield); ;}
    break;

  case 33:
#line 173 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::mag(*(yysemantic_stack_[1].fvfield))); delete (yysemantic_stack_[1].fvfield); ;}
    break;

  case 34:
#line 174 "ValueExpressionParser.yy"
    { (yyval.fsfield) = driver.makeAreaField(); ;}
    break;

  case 35:
#line 175 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::fvc::snGrad(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 36:
#line 176 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::fvc::interpolate(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 37:
#line 177 "ValueExpressionParser.yy"
    {
            (yyval.fsfield)=driver.getFaceScalarField(*(yysemantic_stack_[0].fsname));
                    ;}
    break;

  case 38:
#line 182 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[2].fvfield) + *(yysemantic_stack_[0].fvfield)); delete (yysemantic_stack_[2].fvfield); delete (yysemantic_stack_[0].fvfield); ;}
    break;

  case 39:
#line 183 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[2].fsfield) * *(yysemantic_stack_[0].fvfield)); delete (yysemantic_stack_[2].fsfield); delete (yysemantic_stack_[0].fvfield); ;}
    break;

  case 40:
#line 184 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[2].fvfield) * *(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[2].fvfield); delete (yysemantic_stack_[0].fsfield); ;}
    break;

  case 41:
#line 185 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[2].fvfield) ^ *(yysemantic_stack_[0].fvfield)); delete (yysemantic_stack_[2].fvfield); delete (yysemantic_stack_[0].fvfield); ;}
    break;

  case 42:
#line 186 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[2].fvfield) / *(yysemantic_stack_[0].fsfield)); delete (yysemantic_stack_[2].fvfield); delete (yysemantic_stack_[0].fsfield); ;}
    break;

  case 43:
#line 187 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[2].fvfield) - *(yysemantic_stack_[0].fvfield)); delete (yysemantic_stack_[2].fvfield); delete (yysemantic_stack_[0].fvfield);;}
    break;

  case 44:
#line 188 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(-*(yysemantic_stack_[0].fvfield)); delete (yysemantic_stack_[0].fvfield); ;}
    break;

  case 45:
#line 189 "ValueExpressionParser.yy"
    { (yyval.fvfield) = (yysemantic_stack_[1].fvfield); ;}
    break;

  case 46:
#line 190 "ValueExpressionParser.yy"
    { (yyval.fvfield) = driver.makeFacePositionField(); ;}
    break;

  case 47:
#line 191 "ValueExpressionParser.yy"
    { (yyval.fvfield) = driver.makeFaceField(); ;}
    break;

  case 48:
#line 192 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(Foam::fvc::snGrad(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 49:
#line 193 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(Foam::fvc::interpolate(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 50:
#line 194 "ValueExpressionParser.yy"
    {
            (yyval.fvfield)=driver.getFaceVectorField(*(yysemantic_stack_[0].fvname));
                    ;}
    break;

  case 51:
#line 199 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField((yysemantic_stack_[0].val)); ;}
    break;

  case 52:
#line 200 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) + *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 53:
#line 201 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) - *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 54:
#line 202 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) * *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 55:
#line 203 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) / *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 56:
#line 204 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::pow(*(yysemantic_stack_[3].sfield), (yysemantic_stack_[1].val))); delete (yysemantic_stack_[3].sfield); ;}
    break;

  case 57:
#line 205 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::log(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 58:
#line 206 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::exp(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 59:
#line 207 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].vfield) & *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield);;}
    break;

  case 60:
#line 208 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(-*(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 61:
#line 209 "ValueExpressionParser.yy"
    { (yyval.sfield) = (yysemantic_stack_[1].sfield); ;}
    break;

  case 62:
#line 210 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sqr(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 63:
#line 211 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sqrt(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 64:
#line 212 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sin(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 65:
#line 213 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::cos(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 66:
#line 214 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::tan(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 67:
#line 215 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(Foam::min(*(yysemantic_stack_[1].sfield)).value()); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 68:
#line 216 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(Foam::max(*(yysemantic_stack_[1].sfield)).value()); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 69:
#line 217 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::mag(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 70:
#line 218 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::magSqrGradGrad(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 71:
#line 219 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::mag(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 72:
#line 220 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 73:
#line 221 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[1].fsfield))); delete (yysemantic_stack_[1].fsfield); ;}
    break;

  case 74:
#line 222 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[3].fsfield),*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[3].fsfield); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 75:
#line 223 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::laplacian(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 76:
#line 224 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::laplacian(*(yysemantic_stack_[3].sfield),*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[3].sfield); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 77:
#line 225 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::laplacian(*(yysemantic_stack_[3].fsfield),*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[3].fsfield); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 78:
#line 226 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::average(*(yysemantic_stack_[1].fsfield))); delete (yysemantic_stack_[1].fsfield); ;}
    break;

  case 79:
#line 227 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::surfaceIntegrate(*(yysemantic_stack_[1].fsfield))); delete (yysemantic_stack_[1].fsfield); ;}
    break;

  case 80:
#line 228 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::surfaceSum(*(yysemantic_stack_[1].fsfield))); delete (yysemantic_stack_[1].fsfield); ;}
    break;

  case 81:
#line 229 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[2].vfield)->component(0)); delete (yysemantic_stack_[2].vfield); ;}
    break;

  case 82:
#line 230 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[2].vfield)->component(1)); delete (yysemantic_stack_[2].vfield); ;}
    break;

  case 83:
#line 231 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[2].vfield)->component(2)); delete (yysemantic_stack_[2].vfield); ;}
    break;

  case 84:
#line 232 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doConditional((yysemantic_stack_[4].sfield),(yysemantic_stack_[2].sfield),(yysemantic_stack_[0].sfield),driver.makeScalarField(0.)); delete (yysemantic_stack_[4].sfield); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 85:
#line 233 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(M_PI); ;}
    break;

  case 86:
#line 234 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeDistanceField(); ;}
    break;

  case 87:
#line 235 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeVolumeField(); ;}
    break;

  case 88:
#line 236 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeRandomField(); ;}
    break;

  case 89:
#line 237 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeGaussRandomField(); ;}
    break;

  case 90:
#line 238 "ValueExpressionParser.yy"
    { 
            (yyval.sfield)=driver.getScalarField(*(yysemantic_stack_[0].name));
				;}
    break;

  case 91:
#line 243 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(1); ;}
    break;

  case 92:
#line 244 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(0); ;}
    break;

  case 93:
#line 245 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeCellSetField(*(yysemantic_stack_[1].setname)); ;}
    break;

  case 94:
#line 246 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::less<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 95:
#line 247 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::greater<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 96:
#line 248 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::less_equal<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 97:
#line 249 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::greater_equal<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 98:
#line 250 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::equal_to<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 99:
#line 251 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::not_equal_to<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 100:
#line 252 "ValueExpressionParser.yy"
    { (yyval.sfield) = (yysemantic_stack_[1].sfield); ;}
    break;

  case 101:
#line 253 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalOp((yysemantic_stack_[2].sfield),std::logical_and<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 102:
#line 254 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalOp((yysemantic_stack_[2].sfield),std::logical_or<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 103:
#line 255 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalNot((yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 104:
#line 258 "ValueExpressionParser.yy"
    {     (yyval.vfield) = driver.makeVectorField((yysemantic_stack_[5].sfield),(yysemantic_stack_[3].sfield),(yysemantic_stack_[1].sfield));  delete (yysemantic_stack_[5].sfield); delete (yysemantic_stack_[3].sfield); delete (yysemantic_stack_[1].sfield);}
    break;


      default: break;
    }

/* Line 676 of lalr1.cc.  */
#line 1004 "ValueExpressionParser.tab.cc"

  yypop_ (yylen_);

  YY_STACK_PRINT ();

  yysemantic_stack_.push (yyval);
  yylocation_stack_.push (yyloc);

  /* Shift the result of the reduction.  */
  yyn_ = yyr1_[yyn_];
  yystate_ = yypgoto_[yyn_ - yyntokens_] + yystate_stack_[0];
  if (0 <= yystate_ && yystate_ <= yylast_
      && yycheck_[yystate_] == yystate_stack_[0])
    yystate_ = yytable_[yystate_];
  else
    yystate_ = yydefgoto_[yyn_ - yyntokens_];
  goto yynewstate;

/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus_)
    {
      ++yynerrs_;
      error (yylloc, yysyntax_error_ (YYERROR_VERBOSE_IF (yyilooka)));
    }

  yyerror_range[0] = yylloc;
  if (yyerrstatus_ == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yylooka <= yyeof_)
        {
	  /* Return failure if at end of input.  */
	  if (yylooka == yyeof_)
	    YYABORT;
        }
      else
        {
          yydestruct_ ("Error: discarding", yyilooka, &yylval, &yylloc);
          yylooka = yyempty_;
        }
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (false)
    goto yyerrorlab;

  yyerror_range[0] = yylocation_stack_[yylen_ - 1];
  yypop_ (yylen_);
  yystate_ = yystate_stack_[0];
  goto yyerrlab1;

/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn_ = yypact_[yystate_];
      if (yyn_ != yypact_ninf_)
	{
	  yyn_ += yyterror_;
	  if (0 <= yyn_ && yyn_ <= yylast_ && yycheck_[yyn_] == yyterror_)
	    {
	      yyn_ = yytable_[yyn_];
	      if (0 < yyn_)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yystate_stack_.height () == 1)
	YYABORT;

      yyerror_range[0] = yylocation_stack_[0];
      yydestruct_ ("Error: popping",
                   yystos_[yystate_],
                   &yysemantic_stack_[0], &yylocation_stack_[0]);
      yypop_ ();
      yystate_ = yystate_stack_[0];
      YY_STACK_PRINT ();
    }

  if (yyn_ == yyfinal_)
    goto yyacceptlab;

  yyerror_range[1] = yylloc;
  // Using YYLLOC is tempting, but would change the location of
  // the look-ahead.  YYLOC is available though.
  YYLLOC_DEFAULT (yyloc, yyerror_range - 1, 2);
  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yyloc);

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos_[yyn_],
		   &yysemantic_stack_[0], &yylocation_stack_[0]);

  yystate_ = yyn_;
  goto yynewstate;

  /* Accept.  */
yyacceptlab:
  yyresult_ = 0;
  goto yyreturn;

  /* Abort.  */
yyabortlab:
  yyresult_ = 1;
  goto yyreturn;

yyreturn:
  if (yylooka != yyeof_ && yylooka != yyempty_)
    yydestruct_ ("Cleanup: discarding lookahead", yyilooka, &yylval, &yylloc);

  while (yystate_stack_.height () != 1)
    {
      yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
      yypop_ ();
    }

  return yyresult_;
}

// Generate an error message.
std::string
yy::ValueExpressionParser::yysyntax_error_ (YYERROR_VERBOSE_IF (int tok))
{
  std::string res;
#if YYERROR_VERBOSE
  yyn_ = yypact_[yystate_];
  if (yypact_ninf_ < yyn_ && yyn_ < yylast_)
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  */
      int yyxbegin = yyn_ < 0 ? -yyn_ : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = yylast_ - yyn_;
      int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
      int count = 0;
      for (int x = yyxbegin; x < yyxend; ++x)
        if (yycheck_[x + yyn_] == x && x != yyterror_)
          ++count;

      // FIXME: This method of building the message is not compatible
      // with internationalization.  It should work like yacc.c does it.
      // That is, first build a string that looks like this:
      // "syntax error, unexpected %s or %s or %s"
      // Then, invoke YY_ on this string.
      // Finally, use the string as a format to output
      // yytname_[tok], etc.
      // Until this gets fixed, this message appears in English only.
      res = "syntax error, unexpected ";
      res += yytnamerr_ (yytname_[tok]);
      if (count < 5)
        {
          count = 0;
          for (int x = yyxbegin; x < yyxend; ++x)
            if (yycheck_[x + yyn_] == x && x != yyterror_)
              {
                res += (!count++) ? ", expecting " : " or ";
                res += yytnamerr_ (yytname_[x]);
              }
        }
    }
  else
#endif
    res = YY_("syntax error");
  return res;
}


/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
const signed char yy::ValueExpressionParser::yypact_ninf_ = -63;
const short int
yy::ValueExpressionParser::yypact_[] =
{
     321,   -63,   -63,   -63,   -62,   -63,   -63,   -63,   -51,   -31,
     -28,   -26,   -21,   -18,   -13,   -12,     5,    11,    16,    28,
      30,    34,    35,    39,    40,    42,    43,    44,    47,    48,
      61,    66,    69,    75,   321,   321,   321,    37,   812,   808,
      20,   -63,   321,    -1,    76,    90,    91,    92,   111,   259,
     321,   321,   321,   259,   163,   163,   163,   163,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   102,
     -63,    20,   670,   343,   -47,   812,   808,   -63,   -63,   321,
     321,   321,   321,   321,   321,   -52,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,    96,
     -63,   -63,   -63,   -63,   -63,   101,   -63,   -63,   103,   105,
     106,   119,   120,   123,   259,   259,   681,   -16,   347,   360,
     692,   377,    60,   -46,   124,   163,   163,    64,   322,    79,
     758,   152,   769,   175,   255,   394,   411,   703,   428,   445,
     462,   479,   496,   513,   530,   547,   -63,   -63,   -63,   156,
     156,   -63,   -63,   102,   102,   -63,   -63,   -63,   808,   808,
     808,   808,   808,   808,   -61,   -61,   102,   -63,   -63,   -32,
     666,   137,   -63,   321,   -63,   130,   134,   136,   321,   321,
     259,   -63,   -63,   191,   780,   -63,   163,   163,   163,   163,
     -63,   321,   163,   163,   163,   163,   163,   163,   -63,   -63,
     -63,   321,   -63,   321,   163,   -63,   -63,   -63,   -63,   -63,
     -63,   -63,   199,   -63,   -63,   -63,   -63,   -63,   -63,   -63,
     -63,   -63,   -63,   -63,   321,   321,   317,   -63,   -63,   -63,
     714,   564,   725,   581,   260,   791,   -63,   -63,   -36,   -36,
     -63,   -63,   -63,   736,   598,   121,   133,   133,   -63,   -63,
     -63,   -63,   747,   615,   632,   160,   812,   808,   321,   -63,
     -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,
     -63,   649,   -63
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error.  */
const unsigned char
yy::ValueExpressionParser::yydefact_[] =
{
       0,    90,    24,    51,     0,    91,    92,    85,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     2,
       4,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    12,
      60,     0,     0,     0,     0,     0,     0,   103,     1,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      88,    89,    15,    87,    86,     0,    37,    50,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    13,    61,   100,    11,
       6,     8,     9,    59,    10,    81,    82,    83,    99,    98,
      94,    95,    97,    96,    53,    52,     7,    54,    55,     0,
       0,   102,   101,     0,    93,     0,     0,     0,     0,     0,
       0,    30,    44,     0,     0,    72,     0,     0,     0,     0,
      73,     0,     0,     0,     0,     0,     0,     0,    20,    22,
      70,     0,    75,     0,     0,    79,    18,    80,    19,    78,
      17,    21,     0,    57,    58,    71,    69,    64,    65,    66,
      67,    68,    62,    63,     0,     0,     0,    46,    47,    34,
       0,     0,     0,     0,     0,     0,    31,    45,    29,    25,
      26,    39,    28,     0,     0,     0,    43,    38,    40,    42,
      27,    41,     0,     0,     0,     0,    14,    84,     0,    48,
      35,    49,    36,    32,    33,    23,    74,    16,    77,    76,
      56,     0,   104
};

/* YYPGOTO[NTERM-NUM].  */
const signed char
yy::ValueExpressionParser::yypgoto_[] =
{
     -63,   -63,    49,    22,    51,     0,     4,   -63
};

/* YYDEFGOTO[NTERM-NUM].  */
const short int
yy::ValueExpressionParser::yydefgoto_[] =
{
      -1,    37,    75,   245,   118,    76,    71,    41
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.  */
const signed char yy::ValueExpressionParser::yytable_ninf_ = -1;
const unsigned short int
yy::ValueExpressionParser::yytable_[] =
{
      39,    94,    95,    96,    40,    97,    98,    42,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    43,   224,
     155,   156,   157,   148,   202,   203,   188,   189,    79,    80,
      81,    82,    83,    84,    70,    73,    85,    78,    44,    74,
      77,    45,    99,    46,   186,   187,   188,   189,    47,    38,
     119,    48,   121,   123,   190,   191,    49,    50,   134,   135,
     136,   138,   139,   140,   141,   142,   143,   144,   145,   100,
      96,   117,    97,    98,    51,   122,   127,   129,   131,   133,
      52,   151,   152,    69,    72,    53,   158,   159,   160,   161,
     162,   163,   164,   165,   167,   168,   170,    54,   116,    55,
     120,   171,   172,    56,    57,   128,   130,   132,    58,    59,
     137,    60,    61,    62,    70,    73,    63,    64,   105,    74,
     186,   187,   188,   189,   186,   187,   188,   189,   149,   150,
      65,   201,   153,   154,   205,    66,   181,   183,    67,   186,
     187,   188,   189,   166,    68,   169,   101,   181,   183,   207,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
     102,   103,   104,    69,    72,   182,   184,   173,   106,   107,
      85,   174,   175,   226,   176,   177,   182,   184,   231,   233,
     138,   186,   187,   188,   189,   108,   109,   110,   178,   179,
      98,   244,   180,   204,   111,   194,   195,   196,   197,   112,
     227,   253,   234,   254,   228,   124,   229,   255,   238,   239,
     240,   242,   186,   187,   188,   189,   248,   249,    81,    82,
      83,    84,   209,   125,    85,   257,   234,   230,   232,   137,
     270,   235,   126,     0,     0,   186,   187,   188,   189,   241,
     243,     0,     0,   246,   247,   211,     0,   250,   251,     0,
     252,   186,   187,   188,   189,   235,     0,     0,   271,     0,
       0,   236,     1,     2,   106,   107,     0,     3,     0,     0,
       0,     0,     0,   256,     4,     5,     6,     7,     8,     9,
      10,   108,   109,   110,    11,    12,    13,    14,    15,    16,
     111,    17,    18,    19,    20,   112,    21,    22,    23,    24,
      25,   113,    27,    28,    29,    30,    31,    32,    33,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,   114,
     186,   187,   188,   189,     1,     2,   212,     0,   115,     3,
     263,     0,     0,     0,    36,     0,     4,     5,     6,     7,
       8,     9,    10,     0,     0,     0,    11,    12,    13,    14,
      15,    16,     0,    17,    18,    19,    20,     0,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    34,   192,   193,   194,   195,   196,   197,   258,     0,
      35,     0,   206,     0,     0,     0,    36,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,   192,   193,   194,
     195,   196,   197,   147,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,     0,     0,     0,     0,     0,     0,
     198,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,     0,     0,     0,     0,     0,     0,   200,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,     0,     0,
       0,     0,     0,     0,   213,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,     0,     0,     0,     0,     0,
       0,   214,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,     0,     0,     0,     0,     0,     0,   216,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,     0,
       0,     0,     0,     0,     0,   217,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,     0,     0,     0,     0,
       0,     0,   218,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,     0,     0,     0,     0,     0,     0,   219,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
       0,     0,     0,     0,     0,     0,   220,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,     0,     0,     0,
       0,     0,     0,   221,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,     0,     0,     0,     0,     0,     0,
     222,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,     0,     0,     0,     0,     0,     0,   223,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,     0,     0,
       0,     0,     0,     0,   260,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,     0,     0,     0,     0,     0,
       0,   262,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,     0,     0,     0,     0,     0,     0,   266,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,     0,
       0,     0,     0,     0,     0,   268,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,     0,     0,     0,     0,
       0,     0,   269,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,     0,     0,     0,     0,   225,     0,   272,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      79,    80,    81,    82,    83,    84,     0,     0,    85,     0,
     146,    79,    80,    81,    82,    83,    84,     0,     0,    85,
       0,   185,    79,    80,    81,    82,    83,    84,     0,     0,
      85,     0,   199,    79,    80,    81,    82,    83,    84,     0,
       0,    85,     0,   215,    79,    80,    81,    82,    83,    84,
       0,     0,    85,     0,   259,    79,    80,    81,    82,    83,
      84,     0,     0,    85,     0,   261,    79,    80,    81,    82,
      83,    84,     0,     0,    85,     0,   265,    79,    80,    81,
      82,    83,    84,     0,     0,    85,     0,   267,   192,   193,
     194,   195,   196,   197,     0,     0,     0,     0,   208,   192,
     193,   194,   195,   196,   197,     0,     0,     0,     0,   210,
     192,   193,   194,   195,   196,   197,     0,     0,     0,     0,
     237,   192,   193,   194,   195,   196,   197,     0,     0,     0,
       0,   264,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    79,    80,    81,    82,    83,    84,     0,     0,
      85
};

/* YYCHECK.  */
const short int
yy::ValueExpressionParser::yycheck_[] =
{
       0,    62,    63,    50,     0,    52,    53,    69,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    69,    51,
      72,    73,    74,    70,    70,    71,    62,    63,    60,    61,
      62,    63,    64,    65,    34,    35,    68,     0,    69,    35,
      36,    69,    42,    69,    60,    61,    62,    63,    69,     0,
      50,    69,    52,    53,    70,    71,    69,    69,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    70,
      50,    49,    52,    53,    69,    53,    54,    55,    56,    57,
      69,    81,    82,    34,    35,    69,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    69,    49,    69,
      51,    97,    98,    69,    69,    54,    55,    56,    69,    69,
      61,    69,    69,    69,   114,   115,    69,    69,     7,   115,
      60,    61,    62,    63,    60,    61,    62,    63,    79,    80,
      69,    71,    83,    84,    70,    69,   114,   115,    69,    60,
      61,    62,    63,    94,    69,    96,    70,   125,   126,    70,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      70,    70,    70,   114,   115,   114,   115,    71,     5,     6,
      68,    70,    69,   173,    69,    69,   125,   126,   178,   179,
     180,    60,    61,    62,    63,    22,    23,    24,    69,    69,
      53,   191,    69,    69,    31,    62,    63,    64,    65,    36,
      70,   201,   180,   203,    70,    42,    70,     8,   186,   187,
     188,   189,    60,    61,    62,    63,   194,   195,    62,    63,
      64,    65,    70,    60,    68,   225,   204,   178,   179,   180,
      70,   180,    69,    -1,    -1,    60,    61,    62,    63,   188,
     191,    -1,    -1,   192,   193,    70,    -1,   196,   197,    -1,
     201,    60,    61,    62,    63,   204,    -1,    -1,   258,    -1,
      -1,    70,     3,     4,     5,     6,    -1,     8,    -1,    -1,
      -1,    -1,    -1,   224,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    60,
      60,    61,    62,    63,     3,     4,    71,    -1,    69,     8,
      70,    -1,    -1,    -1,    75,    -1,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    60,    60,    61,    62,    63,    64,    65,    71,    -1,
      69,    -1,    70,    -1,    -1,    -1,    75,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    60,    61,    62,
      63,    64,    65,    70,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    70,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    -1,    -1,    -1,    70,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    70,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    -1,    -1,    -1,    70,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    -1,    -1,    51,    -1,    70,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      60,    61,    62,    63,    64,    65,    -1,    -1,    68,    -1,
      70,    60,    61,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    60,    61,    62,    63,    64,    65,    -1,    -1,
      68,    -1,    70,    60,    61,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    60,    61,    62,    63,    64,    65,
      -1,    -1,    68,    -1,    70,    60,    61,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    60,    61,    62,    63,
      64,    65,    -1,    -1,    68,    -1,    70,    60,    61,    62,
      63,    64,    65,    -1,    -1,    68,    -1,    70,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    70,    60,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,    70,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      70,    60,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      -1,    70,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    60,    61,    62,    63,    64,    65,    -1,    -1,
      68
};

/* STOS_[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
const unsigned char
yy::ValueExpressionParser::yystos_[] =
{
       0,     3,     4,     8,    15,    16,    17,    18,    19,    20,
      21,    25,    26,    27,    28,    29,    30,    32,    33,    34,
      35,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    60,    69,    75,    77,    78,    81,
      82,    83,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    78,
      81,    82,    78,    81,    82,    78,    81,    82,     0,    60,
      61,    62,    63,    64,    65,    68,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    50,    52,    53,    81,
      70,    70,    70,    70,    70,     7,     5,     6,    22,    23,
      24,    31,    36,    42,    60,    69,    78,    79,    80,    81,
      78,    81,    79,    81,    42,    60,    69,    79,    80,    79,
      80,    79,    80,    79,    81,    81,    81,    78,    81,    81,
      81,    81,    81,    81,    81,    81,    70,    70,    70,    78,
      78,    81,    81,    78,    78,    72,    73,    74,    81,    81,
      81,    81,    81,    81,    81,    81,    78,    81,    81,    78,
      81,    82,    82,    71,    70,    69,    69,    69,    69,    69,
      69,    79,    80,    79,    80,    70,    60,    61,    62,    63,
      70,    71,    60,    61,    62,    63,    64,    65,    70,    70,
      70,    71,    70,    71,    69,    70,    70,    70,    70,    70,
      70,    70,    71,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    51,    51,    81,    70,    70,    70,
      78,    81,    78,    81,    79,    80,    70,    70,    79,    79,
      79,    80,    79,    78,    81,    79,    80,    80,    79,    79,
      80,    80,    78,    81,    81,     8,    78,    81,    71,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    81,    70
};

#if YYDEBUG
/* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
   to YYLEX-NUM.  */
const unsigned short int
yy::ValueExpressionParser::yytoken_number_[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      63,    58,   305,   306,   307,   308,    60,    62,   309,   310,
      45,    43,    42,    47,    38,    94,   311,   312,    46,    40,
      41,    44,   120,   121,   122,    33
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
const unsigned char
yy::ValueExpressionParser::yyr1_[] =
{
       0,    76,    77,    77,    77,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    82,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    83
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
const unsigned char
yy::ValueExpressionParser::yyr2_[] =
{
       0,     2,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     2,     3,     5,     3,     6,     4,     4,     4,
       4,     4,     4,     6,     1,     3,     3,     3,     3,     3,
       2,     3,     4,     4,     3,     4,     4,     1,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     4,     4,
       1,     1,     3,     3,     3,     3,     6,     4,     4,     3,
       2,     3,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     6,     4,     6,     6,     4,     4,
       4,     3,     3,     3,     5,     1,     3,     3,     3,     3,
       1,     1,     1,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     8
};

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at \a yyntokens_, nonterminals. */
const char*
const yy::ValueExpressionParser::yytname_[] =
{
  "$end", "error", "$undefined", "\"scalarID\"", "\"vectorID\"",
  "\"faceScalarID\"", "\"faceVectorID\"", "\"cellSetID\"", "\"number\"",
  "\"vector\"", "\"expression\"", "\"lexpression\"", "\"vexpression\"",
  "\"fsexpression\"", "\"fvexpression\"", "TOKEN_VECTOR", "TOKEN_TRUE",
  "TOKEN_FALSE", "TOKEN_pi", "TOKEN_rand", "TOKEN_randNormal",
  "TOKEN_position", "TOKEN_fposition", "TOKEN_face", "TOKEN_area",
  "TOKEN_volume", "TOKEN_dist", "TOKEN_set", "TOKEN_div", "TOKEN_grad",
  "TOKEN_curl", "TOKEN_snGrad", "TOKEN_magSqrGradGrad", "TOKEN_laplacian",
  "TOKEN_integrate", "TOKEN_sum", "TOKEN_interpolate", "TOKEN_average",
  "TOKEN_reconstruct", "TOKEN_pow", "TOKEN_log", "TOKEN_exp", "TOKEN_mag",
  "TOKEN_sin", "TOKEN_cos", "TOKEN_tan", "TOKEN_min", "TOKEN_max",
  "TOKEN_sqr", "TOKEN_sqrt", "'?'", "':'", "TOKEN_OR", "TOKEN_AND",
  "TOKEN_NEQ", "TOKEN_EQ", "'<'", "'>'", "TOKEN_GEQ", "TOKEN_LEQ", "'-'",
  "'+'", "'*'", "'/'", "'&'", "'^'", "TOKEN_NOT", "TOKEN_NEG", "'.'",
  "'('", "')'", "','", "'x'", "'y'", "'z'", "'!'", "$accept", "unit",
  "vexp", "fsexp", "fvexp", "exp", "lexp", "vector", 0
};
#endif

#if YYDEBUG
/* YYRHS -- A `-1'-separated list of the rules' RHS. */
const yy::ValueExpressionParser::rhs_number_type
yy::ValueExpressionParser::yyrhs_[] =
{
      77,     0,    -1,    81,    -1,    78,    -1,    82,    -1,    83,
      -1,    78,    61,    78,    -1,    81,    62,    78,    -1,    78,
      62,    81,    -1,    78,    63,    81,    -1,    78,    65,    78,
      -1,    78,    60,    78,    -1,    60,    78,    -1,    69,    78,
      70,    -1,    82,    50,    78,    51,    78,    -1,    21,    69,
      70,    -1,    33,    69,    79,    71,    78,    70,    -1,    37,
      69,    80,    70,    -1,    34,    69,    80,    70,    -1,    35,
      69,    80,    70,    -1,    29,    69,    81,    70,    -1,    38,
      69,    79,    70,    -1,    30,    69,    78,    70,    -1,    28,
      69,    79,    71,    78,    70,    -1,     4,    -1,    79,    61,
      79,    -1,    79,    62,    79,    -1,    80,    64,    80,    -1,
      79,    63,    79,    -1,    79,    60,    79,    -1,    60,    79,
      -1,    69,    79,    70,    -1,    42,    69,    79,    70,    -1,
      42,    69,    80,    70,    -1,    24,    69,    70,    -1,    31,
      69,    81,    70,    -1,    36,    69,    81,    70,    -1,     5,
      -1,    80,    61,    80,    -1,    79,    62,    80,    -1,    80,
      62,    79,    -1,    80,    65,    80,    -1,    80,    63,    79,
      -1,    80,    60,    80,    -1,    60,    80,    -1,    69,    80,
      70,    -1,    22,    69,    70,    -1,    23,    69,    70,    -1,
      31,    69,    78,    70,    -1,    36,    69,    78,    70,    -1,
       6,    -1,     8,    -1,    81,    61,    81,    -1,    81,    60,
      81,    -1,    81,    62,    81,    -1,    81,    63,    81,    -1,
      39,    69,    81,    71,     8,    70,    -1,    40,    69,    81,
      70,    -1,    41,    69,    81,    70,    -1,    78,    64,    78,
      -1,    60,    81,    -1,    69,    81,    70,    -1,    48,    69,
      81,    70,    -1,    49,    69,    81,    70,    -1,    43,    69,
      81,    70,    -1,    44,    69,    81,    70,    -1,    45,    69,
      81,    70,    -1,    46,    69,    81,    70,    -1,    47,    69,
      81,    70,    -1,    42,    69,    81,    70,    -1,    32,    69,
      81,    70,    -1,    42,    69,    78,    70,    -1,    28,    69,
      78,    70,    -1,    28,    69,    79,    70,    -1,    28,    69,
      79,    71,    81,    70,    -1,    33,    69,    81,    70,    -1,
      33,    69,    81,    71,    81,    70,    -1,    33,    69,    79,
      71,    81,    70,    -1,    37,    69,    79,    70,    -1,    34,
      69,    79,    70,    -1,    35,    69,    79,    70,    -1,    78,
      68,    72,    -1,    78,    68,    73,    -1,    78,    68,    74,
      -1,    82,    50,    81,    51,    81,    -1,    18,    -1,    26,
      69,    70,    -1,    25,    69,    70,    -1,    19,    69,    70,
      -1,    20,    69,    70,    -1,     3,    -1,    16,    -1,    17,
      -1,    27,    69,     7,    70,    -1,    81,    56,    81,    -1,
      81,    57,    81,    -1,    81,    59,    81,    -1,    81,    58,
      81,    -1,    81,    55,    81,    -1,    81,    54,    81,    -1,
      69,    82,    70,    -1,    82,    53,    82,    -1,    82,    52,
      82,    -1,    75,    82,    -1,    15,    69,    81,    71,    81,
      71,    81,    70,    -1
};

/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
const unsigned short int
yy::ValueExpressionParser::yyprhs_[] =
{
       0,     0,     3,     5,     7,     9,    11,    15,    19,    23,
      27,    31,    35,    38,    42,    48,    52,    59,    64,    69,
      74,    79,    84,    89,    96,    98,   102,   106,   110,   114,
     118,   121,   125,   130,   135,   139,   144,   149,   151,   155,
     159,   163,   167,   171,   175,   178,   182,   186,   190,   195,
     200,   202,   204,   208,   212,   216,   220,   227,   232,   237,
     241,   244,   248,   253,   258,   263,   268,   273,   278,   283,
     288,   293,   298,   303,   308,   315,   320,   327,   334,   339,
     344,   349,   353,   357,   361,   367,   369,   373,   377,   381,
     385,   387,   389,   391,   396,   400,   404,   408,   412,   416,
     420,   424,   428,   432,   435
};

/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
const unsigned short int
yy::ValueExpressionParser::yyrline_[] =
{
       0,   136,   136,   137,   138,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   258
};

// Print the state stack on the debug stream.
void
yy::ValueExpressionParser::yystack_print_ ()
{
  *yycdebug_ << "Stack now";
  for (state_stack_type::const_iterator i = yystate_stack_.begin ();
       i != yystate_stack_.end (); ++i)
    *yycdebug_ << ' ' << *i;
  *yycdebug_ << std::endl;
}

// Report on the debug stream that the rule \a yyrule is going to be reduced.
void
yy::ValueExpressionParser::yyreduce_print_ (int yyrule)
{
  unsigned int yylno = yyrline_[yyrule];
  /* Print the symbols being reduced, and their result.  */
  *yycdebug_ << "Reducing stack by rule " << yyn_ - 1
             << " (line " << yylno << "), ";
  for (unsigned short int i = yyprhs_[yyn_];
       0 <= yyrhs_[i]; ++i)
    *yycdebug_ << yytname_[yyrhs_[i]] << ' ';
  *yycdebug_ << "-> " << yytname_[yyr1_[yyn_]] << std::endl;
}
#endif // YYDEBUG

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
yy::ValueExpressionParser::token_number_type
yy::ValueExpressionParser::yytranslate_ (int token)
{
  static
  const token_number_type
  translate_table[] =
  {
         0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    75,     2,     2,     2,     2,    64,     2,
      69,    70,    62,    61,    71,    60,    68,    63,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    51,     2,
      56,     2,    57,    50,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    65,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      72,    73,    74,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    52,    53,    54,    55,    58,
      59,    66,    67
  };
  if ((unsigned int) token <= yyuser_token_number_max_)
    return translate_table[token];
  else
    return yyundef_token_;
}

const int yy::ValueExpressionParser::yyeof_ = 0;
const int yy::ValueExpressionParser::yylast_ = 880;
const int yy::ValueExpressionParser::yynnts_ = 8;
const int yy::ValueExpressionParser::yyempty_ = -2;
const int yy::ValueExpressionParser::yyfinal_ = 78;
const int yy::ValueExpressionParser::yyterror_ = 1;
const int yy::ValueExpressionParser::yyerrcode_ = 256;
const int yy::ValueExpressionParser::yyntokens_ = 76;

const unsigned int yy::ValueExpressionParser::yyuser_token_number_max_ = 312;
const yy::ValueExpressionParser::token_number_type yy::ValueExpressionParser::yyundef_token_ = 2;

#line 261 "ValueExpressionParser.yy"


void yy::ValueExpressionParser::error (const yy::ValueExpressionParser::location_type& l,const std::string& m)
{
     driver.error (l, m);
}

